<?php

  /*
   This file is part of MoreGroupWare's webmail2 module
   Copyright 2004-2005 Franky Van Liedekerke
   This module is released under the GPL (as stated below).

   Originally written by Thomas Bley (info@simple-groupware.de),
   now adapted and maintained by Franky Van Liedekerke.

   You should have received a copy of the GNU General Public License
   along with mgw; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */


// Sendmail_post
// Moregroupware.org

$myEnv["module"] = "webmail2";
$myEnv["stdsmenu"] = false;
$myEnv["output"] = "html";

include("../../config.inc.php");
include(INCLUDEPATH . "container.inc.php");
require_once(WM2_INC_DIR."pear/Mail.php");
require_once(WM2_INC_DIR."pear/Mail/mime.php");
require_once(WM2_INC_DIR."pear/Mail/RFC822.php");
include(WM2_INC_DIR.'sendmail_post_inc.php');

require_once(INCLUDEPATH . "crypt.inc.php");
$myC = new Crypto();

error_reporting  (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

$myvars = array("from","to","cc","bcc","subject","signit","sendplain","notification","msgbody","msgbody_text","replyto","priority","saveto","function","slcsil","forward","editmail","inreplyto","orig_mbox_id","orig_account");
foreach ($myvars as $thevar) {
  ${$thevar} = quote2((isset($_GET[$thevar])) ? $_GET[$thevar] : (isset($_POST[$thevar]) ? $_POST[$thevar] : ""));
}

$smarty->assign("username", ucfirst($username));
$webmail_sendmail_temp_dir = CACHE_FOLDER."$username/sendmail/";

$mysession_vars = array("msgbody","msgbody_text","subject","from","to","cc","bcc","priority","signit","sendplain","notification","forward","editmail","replyto","inreplyto","orig_mbox_id","orig_account");
foreach ($mysession_vars as $thevar) {
  if (${$thevar}!="<empty>") {
    $_SESSION["webmail2_compose_array"][$thevar] = htmlspecialchars(${$thevar});
  }
}

$back_button = '
      <form method="post" action="sendmail.php">
        <input type="hidden" name="signit2" value="yes">
        <input type="hidden" name="sendplain2" value="yes">
        <input type="hidden" name="notification2" value="yes">
		<input type="hidden" name="'.session_name().'" value="'.session_id().'">			
        <input type="submit" class="submit" value="'.Lang::getLanguageString("attachments_go_back").'">
      </form>
';

$myvars = array("from","to","cc","bcc","signit","sendplain","notification","msgbody","msgbody_text","replyto","priority","saveto","function","slcsil","forward","editmail","orig_mbox_id","orig_account");
foreach ($myvars as $thevar) {
  ${$thevar} = myquote((isset($_GET[$thevar])) ? $_GET[$thevar] : (isset($_POST[$thevar]) ? $_POST[$thevar] : ""));
}
if ($to=="" and $cc=="" and $bcc=="" and $saveto!="draft") {Header("Location: sendmail.php?sendplain2=yes&signit2=yes&notification2=yes&errorstate=posterror&".SID); die;}

if ($saveto=="draft") {
  $mbox_id = getboxid("draft",0,$user_id);
} else {
  $mbox_id = getboxid("sent",0,$user_id);
}

$to = stripslashes($to);
$cc = stripslashes($cc);
$bcc = stripslashes($bcc);

$toarr = make_array_adr($to);
$ccarr = make_array_adr($cc);
$bccarr = make_array_adr($bcc);

$tolocalarr = array();
$tolocalarrgroup = array();
$toarrgroup = array();

$arr_local= array();
$arr_localgroups = array();
$arr_remote = array();
$arr_groups = array();

list($arr_local,$arr_localgroups,$arr_remote,$arr_groups)=add_adr_to_arr($tolocalarr,$tolocalarrgroup,$toarr,$toarrgroup);
$toarr=array_merge($arr_remote,group_to_arr($arr_groups,$arr_remote));
$tolocalarr=$arr_local;
// for the group, the indexes are important (they are also the group index)
// so we keep them
$toarrgroup=$toarrgroup+$arr_groups;
$tolocalarrgroup =$tolocalarrgroup+$arr_localgroups;

list($arr_local,$arr_localgroups,$arr_remote,$arr_groups)=add_adr_to_arr($tolocalarr,$tolocalarrgroup,$ccarr,$toarrgroup);
$ccarr=array_merge($arr_remote,group_to_arr($arr_groups,$arr_remote));
$tolocalarr=$tolocalarr+$arr_local;
$toarrgroup=$toarrgroup+$arr_groups;
$tolocalarrgroup =$tolocalarrgroup+$arr_localgroups;

list($arr_local,$arr_localgroups,$arr_remote,$arr_groups)=add_adr_to_arr($tolocalarr,$tolocalarrgroup,$bccarr,$toarrgroup);
$bccarr=array_merge($arr_remote,group_to_arr($arr_groups,$arr_remote));
$tolocalarr=$tolocalarr+$arr_local;
// $toarrgroup is only used in the call to add_adr_to_arr, so we don't need it here any more
// $toarrgroup=$toarrgroup+$arr_groups;
$tolocalarrgroup =$tolocalarrgroup+$arr_localgroups;
unset($arr_local,$arr_localgroups,$arr_remote,$arr_groups);

$tolocalarr=$tolocalarr+localgroup_to_arr($tolocalarrgroup,$tolocalarr);

$sendto = implode(",",$toarr);
$sendcc = implode(",",$ccarr);
$sendbcc = implode(",",$bccarr);
$sendlocal = implode(",",$tolocalarr);

if ($sendlocal=="" and $sendcc=="" and $sendto=="" and $saveto!="draft") {Header("Location: sendmail.php?sendplain2=yes&signit2=yes&notification2=yes&errorstate=posterror&".SID); die;}

$sql = "select * from mgw_webmail2_accounts where user_id=".(int)$user_id." and id=".(int)$from;
if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
$row = $res->FetchRow();


$msgbody = stripslashes($msgbody);
$msgbody_text = stripslashes($msgbody_text);
// txtbody is msgbody converted to txt, this is when somebody typed a HTML mail
$txtbody = str_replace(array("\n","<br />","<br>","<p>","</p>"),array("","\n","\n","\n","\n\n"),$msgbody);
if (str_replace(array("\r","\n"),"",$msgbody_text)=="") $msgbody_text="";

if ($signit=="checked" and $row["signature_html"]!="") {
  if (!strpos($msgbody,"<signature />")) {
    $msgbody .= "<br><br>-- <br>".$row["signature_html"];
  } else {
    $msgbody = str_replace("<signature />","<br>-- <br>".$row["signature_html"]."<br><br><br>",$msgbody);
  }
}

if ($signit=="checked" and $row["signature"]!="") {
  if ($msgbody_text!="") $msgbody_text .= "\n\n-- \n".$row["signature"];
  if (!strpos($txtbody,"<signature />")) {
    $txtbody .= "\n\n-- \n".$row["signature"];
  } else {
    $txtbody = str_replace("<signature />","\n-- \n".$row["signature"]."\n\n\n",$txtbody);
  }
}

$txtbody = strip_tags($txtbody);
# it seems the compose form also uts in some lonely \r characters
#    instead of \r\n ...
$msgbody = str_replace("\r","",$msgbody);
$txtbody = str_replace("\r","",$txtbody);

$txtbody = my_decodeHTML($txtbody);

if ($row["password"]!="") {$password = $myC->decrypt($username, $row["password"]);} else {$password = "";}
if ($row["smtppassword"]!="") {$thesmtppassword = $myC->decrypt($username, $row["smtppassword"]);} else {$thesmtppassword = "";}

if ($row["smtpauth"]=="checked") {
  $smtpauth = true;
  if ($row["smtpusepopuser"]=="checked") {
    $smtpusername = $row["username"];
    $smtppassword = $password;
  } else {
    $smtpusername = $row["smtpusername"];
    $smtppassword = $thesmtppassword;
  }
} else {
  $smtpusername = "";
  $smtppassword = "";
  $smtpauth = false;
}

// if pop before smtp is needed, we do it here
check_pop_sendmail($row,$saveto,(count($toarr)+count($ccarr)+count($bccarr)));

$crlf="\n";
$mime = new Mail_mime($crlf);

if ($msgbody_text!="") {
  $mime->setTXTBody($msgbody_text);
} else {
  if ($msgbody=="") $msgbody = " ";
  $mime->setTXTBody($txtbody);
  $mime->setHTMLBody($msgbody);
}

// the next function changes $mime also
$attaches=add_attachments_sendmail($webmail_sendmail_temp_dir);

$mail_attachments = array();
if (isset($mail->attachments) and count($mail->attachments)!=0) {
  foreach ($mail->attachments as $att) {
    $mail_attachments[] = $att['body'];
  }
}


$mydate = date("D, d M Y H:i:s O");

$recipients_arr= array_merge($toarr,$ccarr,$bccarr);
$recipients= implode(",",$recipients_arr);

$headers = array(
		'From'=>$row["fullname"]." <".$row["replyto"].">",
		'To'=>$to,
		'Cc'=>$cc,
		'Subject'=>$subject,
		'Date'=>$mydate,
		'X-Priority'=>$priority,
		'References'=>$inreplyto,
		'In-Reply-To'=>$inreplyto,
		'X-Mailer'=>'Moregroupware Webmail2'
);

if ($notification) {
  $headers['Disposition-Notification-To'] = $row["fullname"].'" <'.$row["replyto"].'>';
}

// adding carriage returns for compatiblity
$body = preg_replace("/(\r\n|\n)/","\r\n",$mime->get());
$headers = $mime->headers($headers);
if ($bcc!="") {
  $headers_with_bcc = $mime->headers(array('Bcc'=>$bcc));
}
// if no local persons see this mail, we can add the bcc header info as well
if ($bcc!="" && count($tolocalarr) == 0) {
  $headers=$headers_with_bcc;
}

mt_srand((double)microtime()*10000);

$msg_id = mgw_genID('mgw__seq_messages');
//$dir_nr = getdirnr($msg_id);
//checkdir(STORE_FOLDER.$dir_nr."/",false);
//$act_name = STORE_FOLDER.$dir_nr."/" . $msg_id . "-" .date("dmY-His")."-". ereg_replace("/","X",md5(mt_rand(1,6000))).".eml";
$act_name = STORE_FOLDER.$username."/" . $msg_id . "-" .date("dmY-His")."-". ereg_replace("/","X",md5(mt_rand(1,6000))).".eml";

$uid = "<".date("YmdHi").".".substr(ereg_replace("/","X",md5(mt_rand(1,6000))),0,12)."@".$_SERVER["SERVER_NAME"].">";

if ($attaches!=0) {$attaches = 1;}

$to2 = $sendto;
if ($sendcc != "") {
  if ($to2 != "") {$to2 .= ", "; }
  $to2 .= $sendcc;
}
if ($sendbcc != "") {
  if ($to2 != "") {$to2 .= ", "; }
  $to2 .= $sendbcc;
}
if ($sendlocal != "") {
  if ($to2 != "") {$to2 .= ", "; }
  $to2 .= $sendlocal;
}

$to2 = htmlspecialchars($to2);
$to22 = $to2;

if (!isset($act_name_with_bcc)) $act_name_with_bcc = $act_name;

$txt_headers = "";
foreach ($headers as $key=>$value) {
   $txt_headers .= "$key: $value\n";
}
$txt_headers .= "\n";
// add carriage returns for compatibility
$txt_headers = preg_replace("/(\r\n|\n)/","\r\n",$txt_headers);

// save in Sent
$save_success = FALSE;

$sent_name="";
if (is_imaponly_account($from) && !use_local_sent($from)) {
  if ($email = connect_my_imap($from, "INBOX", true)) {
    if (sqimap_mailbox_exists($email, $sent_name) and $sent_name!="") {
      sqimap_append($email, $sent_name, $txt_headers.$body, strlen($txt_headers.$body));
      sqimap_append_done($email);
      $save_success = TRUE;

    } else {
      Header("Location: sendmail.php?sendplain2=yes&signit2=yes&notification2=yes&errorstate=sentnotfound&".SID);
    }
  }
} else {
  if ($msg_id == "") { $msg_id = mgw_genID('mgw__seq_messages'); }
  if ($replyto == "") { $replyto = 0; }
  $myids[] = $msg_id;
  $sql = "INSERT INTO mgw_webmail2_messages (cal_accepted,notified,attachbit,msg_cache,message_id,account_name,uid,type,mbox_id,header_from,header_to,header_cc,header_bcc,header_replyto,header_date,header_subject,header_inreplyto,msg_body,recentbit,readbit,replybit,draftbit,flaggedbit,forwardbit,replied2,labelbit) VALUES('1','1','".$attaches."','".ereg_replace("/","X",md5(mt_rand(1,6000)))."',".(int)$msg_id.",'".$row["username"]."@".$row["pophost"]."','".$uid."','eml',".(int)$mbox_id.",".$conn->Quote($row["fullname"]." (".$username.") <".$row["replyto"].">").",".$conn->Quote($to).",".$conn->Quote($cc).",".$conn->Quote($bcc).",'','".time()."',".$conn->Quote($subject).",'".$inreplyto."','".$act_name_with_bcc."','1','0','0','0','".$priority."','0',".(int)$replyto.",'0')";
  if(!$res = $conn->Execute($sql)) {
    die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
  } else {
    writetofile_sendmail($act_name,$txt_headers.$body);

    if (file_exists($act_name)) {
      foreach ($myids as $myid) {
        $sql = "update mgw_webmail2_messages set header_size=".(int)filesize($act_name)." where message_id=".(int)$myid;
        if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
      }
    }
  
    if ($bcc!="" and count($tolocalarr) != 0) {
       $txt_headers = "";
         foreach ($headers_with_bcc as $key=>$value) {
          $txt_headers .= "$key: $value\n";
       }
       $txt_headers .= "\n";
       writetofile_sendmail($act_name_with_bcc,$txt_headers.$body);

      if ($editmail!="" and has_write_rights_mail($editmail,$user_id)) {
        $folderto = getboxid("trash",0,$user_id);
        $folderfrom = getboxid("draft",0,$user_id);

        $sql = "update mgw_webmail2_messages set mbox_id=".(int)$folderto." where mbox_id=".(int)$folderfrom." and message_id=".(int)$editmail;
        if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
      }

    }

    $save_success = TRUE;
  }
}

if ($save_success) {

  // update replyto flag
  if ($replyto!="" and $saveto!="draft") {
    if ($orig_account != 0) {
      // open account where original mail replied to is stored...
      if ($email = connect_my_imap($orig_account,$orig_mbox_id , true)) {
        sqimap_messages_flag($email, $replyto, $replyto, '\Answered');
      } 
    } else {
      if (has_write_rights_mail($replyto,$user_id)) { add_to_replied($replyto,$msg_id,$to22);}
    }
  } elseif ($saveto=="draft" and $replyto!="") {
    if (has_write_rights_mail($replyto,$user_id)) {
      $sql = "update mgw_webmail2_messages set reply_draft=".(int)$replyto." where message_id=".(int)$msg_id;
      if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
    }
  }

  // update forwarded flag
  if ($forward!="" and $saveto!="draft") {
    if ($orig_account != 0) {
      // open account where original mail forwarded to is stored...
      // FIXME  no standard support for forwarded in imap.
    } else {
      if (has_write_rights_mail($forward,$user_id)) { add_to_forwarded($forward,$msg_id,$to22); }
    }
  } elseif ($saveto=="draft" and $forward!="") {
    $sql = "update mgw_webmail2_messages set forward_draft=".(int)$forward." where message_id=".(int)$msg_id;
    if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__,__FILE__));
  }

  if ($saveto!="draft") {
    // send the email...
    // if the mail is also send to local users, they don't need the bcc info if there was any
    // so then we create a second eml message, without the bcc info
    if ($bcc!="" and count($tolocalarr) != 0) {

        $msg_id2 = mgw_genID('mgw__seq_messages');
        $act_name_with_bcc = STORE_FOLDER.$username."/" . $msg_id2 . "-" .date("dmY-His")."-". ereg_replace("/","X",md5(mt_rand(1,6000))).".eml";

        $uid2 = "<".date("YmdHi").".".substr(ereg_replace("/","X",md5(mt_rand(1,6000))),0,12)."@".$_SERVER["SERVER_NAME"].">";
    } 
    if (count($tolocalarr) != 0) {
        foreach ($tolocalarr as $key=>$key2) {
          if (!isset($act_name_with_bcc)) {
            $msg_id2 = $msg_id;
            $msg_id = "";
            $uid2 = $uid;
          }
          $the_user_id = $key;
      
          if (!boxexist2("inbox",0,$the_user_id)) {
            create_boxes(array(array("inbox",0,$the_user_id)));
          }
          $the_mbox_id = getboxid("inbox",0,$key);
      
          if ($msg_id2 == "") { 
            $msg_id2 = mgw_genID('mgw__seq_messages'); 
          }

          $myids[] = $msg_id2;
          $sql = "INSERT INTO mgw_webmail2_messages (cal_accepted,notified,attachbit,msg_cache,message_id,account_name,uid,type,mbox_id,header_from,header_to,header_cc,header_bcc,header_replyto,header_date,header_subject,header_inreplyto,msg_body,recentbit,readbit,replybit,draftbit,flaggedbit,forwardbit,replied2,labelbit) VALUES".
          "('0','0','".$attaches."','".ereg_replace("/","X",md5(mt_rand(1,6000)))."',".(int)$msg_id2.",'".$row["username"]."@".$row["pophost"]."','".$uid2."','eml',".(int)$the_mbox_id.",".$conn->Quote($row["fullname"]." (".$username.") <".$row["replyto"].">").",".$conn->Quote($to).",".$conn->Quote($cc).",'','','".time()."',".$conn->Quote($subject).",'".$inreplyto."','".$act_name."','1','1','0','0','".$priority."','0',0,'0')";
          if(!$res = $conn->Execute($sql)) die(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

          $msg_id2 = "";
        }
    }
    if (count($toarr)+count($ccarr)+count($bccarr) != 0) {
  
      if ($row["enable_ssl_smtp"]=="checked") {
        $port = "465";
        $hostname = "ssl://".$row["smtphost"];
      } else {
        $port = "25";
        $hostname = $row["smtphost"];
      }
      if (!empty($row["smtpport"])) {
        $port = $row["smtpport"];
      }

      $smtp_params=array('host'=>$hostname,'port'=>$port,'localhost'=>$_SERVER["SERVER_NAME"],'auth'=>$smtpauth,'username'=>$smtpusername,'password'=>$smtppassword);
      $smtp =& Mail::factory('smtp',$smtp_params);
      if (PEAR::isError($smtp)) {
        show_webmail_error($back_button.Lang::getLanguageString("sendmail_post_error"),$smtp->message);
      }
      $result=$smtp->send($recipients,$headers,$body);
      if (PEAR::isError($result)) {
        show_webmail_error($back_button.Lang::getLanguageString("sendmail_post_error"),$result->message);
      }
      unset($result);
      unset($smtp);
    }
    $message = Lang::getLanguageString("sendmail_post_successfully_sent");

    // delete cached and session data for this message
    delete_open_attachments($webmail_sendmail_temp_dir);
    $_SESSION["webmail2_compose_array"] = array();
    unset($_SESSION["webmail2_compose_array"]);

    $to2 = $to2."<br>";
  } else {
    $message = Lang::getLanguageString("sendmail_post_email_was_saved");
    $to2 = "";
  }

  $smarty->assign("waittime", $MGW->settings["wm2_waittime"]);
  $smarty->assign("message", $message);
  $smarty->assign("to2", $to2);
  $smarty->assign("saveto", $saveto);

  $smarty->display("sendmail_post.tpl");
}

?>
