<?php
/* insertion moregroupware */
$myEnv["module"] 	= "faq";
$myEnv["output"] 	= "html";
$myEnv["stdsmenu"] 	= true;

if((isset($_POST["op"]) && ($_POST["op"] == "exportpdf")) ||
   (isset($_GET['view']) && (strstr($_GET['view'], 'vcardexport')))) session_cache_limiter("public");

include("../../config.inc.php");

include(INCLUDEPATH . "container.inc.php");
/* ----------------- */
/******************************************************************************
 * File:				index.php
 * Authors:				Thorsten Rinne		thorsten@rinne.info
 * 						Bastian Pttner		bastian@poettner.net
 * Date:				2001-02-12
 * Last Update:			2004-01-20
 * Copyright:           (c) 2001-2002 Thorsten Rinne und Bastian Pttner
 *                      (c) 2001-2004 Thorsten Rinne
 * 
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 ******************************************************************************/

/* debug mode:
 * - FALSE	debug mode disabled
 * - TRUE	debug mode enabled
 */
define("DEBUG", FALSE);

if (DEBUG == TRUE) {
	error_reporting(E_ALL);
	}

/* are install.php or update.php not deleted yet? */
if (file_exists("install/installer.php")) {
	die("<p align=\"center\"><b>Attention !!</b><br>Please delete the file <b>\"installer.php\"</b> in the directory <b>\"install/\"!</b></p>\n");
	}
if (file_exists("install/update.php")) {
	die("<p align=\"center\"><b>Attention !!</b><br>Please delete the file <b>\"update.php\"</b> in the directory <b>\"install/\"!</b></p>\n");
	}

/* connect to the database server */
require ("inc/data.php");
require ("inc/database.php");
$db = new db_mysql();
$db->connect($mysql_server, $mysql_user, $mysql_passwort, $mysql_db);

/* get functions, template parser and configuration */
require ("inc/functions.php");
require ("inc/parser.php");
require ("inc/config.php");
/* insertion moregroupware */
require_once("faq.class.php");
/* ----------------------- */

/* get language (default: english) */
if (!isset($sprache) || !is_file("lang/".$sprache)) {
	include "lang/english.php";
	}
else {
	include "lang/".$sprache;
	}

/* found a session ID? */
if (!isset($_REQUEST["sid"])) {
	Tracking("NewSession", 0);
	}
else {
	if (isset($_REQUEST["id"]) && checkIntVar($_REQUEST["id"]) == TRUE) {
		CheckSID($_REQUEST["sid"], getenv("REMOTE_ADDR"));
		}
	}

/* is user tracking activated? */
if ($tracking == TRUE) {
	if (isset($sid)) {
		$sids = "sid=".$sid."&amp;";
		}
	elseif (isset($_REQUEST["sid"])) {
		$sids = "sid=".$_REQUEST["sid"]."&amp;";
		}
	}
else {
	$sids = "";
	}

/* found a record ID? */
if (isset($_REQUEST["id"]) && checkIntVar($_REQUEST["id"]) == TRUE) {
	$id = $_REQUEST["id"];
	}
else {
	$id = "";
	}
if (isset($_REQUEST["lang"])) {
	$lang = $_REQUEST["lang"];
	}
else {
	$lang = "";
	}

/* found a category? */
if (isset($_REQUEST["rubrik"])) {
	$printMainCategories = printMainCategories($_REQUEST["rubrik"]);
	}
else {
	$printMainCategories = printMainCategories();
	}

/* select the template for the requested page */
if (isset($_REQUEST["aktion"])) {
	$includeFile = $_REQUEST["aktion"];
	}
else {
	$includeFile = "main";
	}

/* insertion moregroupware */
/* load templates */
$tpl = new mgw_phpmyfaqTemplate ( array(
				"index" => 'template/index.html',
				"writeContent" => 'template/'.$includeFile.'.html'
				));
// $tpl = new phpmyfaqTemplate ( array(
//				"index" => 'template/index.html',
//				"writeContent" => 'template/'.$includeFile.'.html'
//				));
/* ------------------- */

/* get main template, set main variables */
$tpl->processTemplate ("index", array(
				"writeTitle" => $title.' - powered by phpMyFAQ',
				"metaDescription" => $metaDescription,
				"metaKeywords" => $metaKeywords,
				"metaPublisher" => $metaPublisher,
				"metaLanguage" => $metaLanguage,
				"metaCharset" => $metaCharset,
				"ID" => $id,
				"LANG" => $lang,
				"msgSearch" => '<a href="'.$_SERVER["PHP_SELF"]."?".$sids.'aktion=search">'.$msgSearch.'</a>',
				"msgAddContent" => '<a href="'.$_SERVER["PHP_SELF"]."?".$sids.'aktion=add">'.$msgAddContent.'</a>',
				"msgQuestion" => '<a href="'.$_SERVER["PHP_SELF"]."?".$sids.'aktion=ask">'.$msgQuestion.'</a>',
				"msgOpenQuestions" => '<a href="'.$_SERVER["PHP_SELF"]."?".$sids.'aktion=open">'.$msgOpenQuestions.'</a>',
				"msgHelp" => '<a href="'.$_SERVER["PHP_SELF"]."?".$sids.'aktion=hilfe">'.$msgHelp.'</a>',
				"msgContact" => '<a href="'.$_SERVER["PHP_SELF"]."?".$sids.'aktion=kontakt">'.$msgContact.'</a>',
				"msgCategory" => $msgCategory,
				"allCategories" => '<b>&middot;</b> <a href="'.$_SERVER["PHP_SELF"]."?".$sids.'aktion=anzeigen">'.$msgShowAllCategories.'</a>',
				"showCategories" => $printMainCategories,
				"backToHome" => '<b>&middot;</b> <a href="'.$_SERVER["PHP_SELF"]."?".$sids.'">'.$msgHome.'</a>',
				"userOnline" => userOnline(),
				"copyright" => 'powered by <a href="http://www.phpmyfaq.de" target="_blank">phpMyFAQ</a> '.$version));

/* include requested files */
if (isset($_REQUEST["aktion"])) {
	include($_REQUEST["aktion"].".php");
	}
else {
	include("main.php");
	}

/* insertion moregroupware */
/* print template */
//print($tpl->printTemplate());
$smarty->assign("corps",$tpl->printTemplate());
// $smarty->assign("corps","Le <strong>petit</strong><br> chat est mort");
// print("Le <strong>petit</strong><br> chat est mort");
// $tpl->printTemplate();
/* ------------------- */

if (DEBUG == TRUE) {
	print "<p>".$db->sqllog()."</p>";
	print "<p>".$db->countqueries()." Queries executed</p>";
	}

/* disconnect from database */
$db->dbclose();

/* insertion moregroupware */
$smarty->assign("contentheader",$hashmap[libel_faq]);
$smarty->display("faq.tpl");
/* ------------------- */
?>