<?php

class forumSettings extends CObject {
	
	
	/********************************************************
	* All default settings for the forum are set here.
	* The include path and the root_url must be set manually!
	***/
	function forumSettings() {
		/***********************
		* Forum properties
		***/
		
		//define the style of icons
		
		$this->regVar("with_icons",					0,									  false, true, "se_*");
		$this->regVar("iconset",						0,									  false, true, "se_*");
		$this->regVar("with_moderators",		1, 										false, true, "se_*");
		$this->regVar("with_groups", 				1, 										false, true, "se_*");
		$this->regVar("with_user_rating", 	1, 										false, true, "se_*");
		$this->regVar("with_search", 				1, 										false, true, "se_*");
		$this->regVar("with_user_profiles",	1, 										false, true, "se_*");
		$this->regVar("with_email_notify",	1, 										false, true, "se_*");
		$this->regVar("with_signature",		1, 										false, true, "se_*");
		$this->regVar("with_userLogo",			1, 										false, true, "se_*");
		$this->regVar("with_format_code",		1, 										false, true, "se_*");
		$this->regVar("allow_guests",				1, 										false, true, "se_*");
		$this->regVar("allow_html",					1, 										false, true, "se_*");
		$this->regVar("allow_userEditOwnThread",1, 								false, true, "se_*");
		$this->regVar("user_rating_img",	 	"star.gif", 					false, true, "se_*");
		$this->regVar("sql_db_type",				"mysql",							false, true, "se_*");
		$this->regVar("sql_db_name",				"forum",							false, true, "se_*");
		$this->regVar("sql_userLog_table",	"forum_users",				false, true, "se_*");
		$this->regVar("sql_user_table", 		"forum_users", 				false, true, "se_*");
		$this->regVar("sql_grp_table", 			"forum_groups",				false, true, "se_*");
		$this->regVar("sql_frm_table", 			"forum_forums",				false, true, "se_*");
		$this->regVar("sql_thread_table", 	"forum_threads",			false, true, "se_*");
		$this->regVar("sql_moderator_table","forum_moderators",		false, true, "se_*");
		$this->regVar("sql_user_settings_table","settings_forum",	false, true, "se_*");


		// Group list
		$this->regVar("grpLst_showNumThreads",			1,					 					false, true, "se_*");
		$this->regVar("grpLst_showNumPosts", 				1, 										false, true, "se_*");
		$this->regVar("grpLst_showNewPostsStat",		1, 										false, true, "se_*");
		$this->regVar("grpLst_lastPost",			 			1, 										false, true, "se_*");
		$this->regVar("grpLst_noNewThreadIcon",			"grp_noNewMsg_0.gif",		false, true, "se_*");
		$this->regVar("grpLst_newThreadIcon", 			"grp_newMsg_0.gif",			false, true, "se_*");
		$this->regVar("grpLst_lockedThreadIcon",		"grp_lockedMsg_0.gif",	false, true, "se_*");
		$this->regVar("grpLst_animatedIcons",				1,										false, true, "se_*");
		

		// Message/Threads list
		$this->regVar("threadLst_showNumPosts", 		1, 										false, true, "se_*");
		$this->regVar("threadLst_showNumViews", 		1, 										false, true, "se_*");
		$this->regVar("threadLst_showRating", 			1, 										false, true, "se_*");
		$this->regVar("threadLst_showAuthor", 			1, 										false, true, "se_*");
		$this->regVar("threadLst_showDate", 				1, 										false, true, "se_*");
		$this->regVar("threadLst_showViewed", 			1, 										false, true, "se_*");
		$this->regVar("threadLst_viewedIcon", 			"msg_viewed_0.gif", 		false, true, "se_*");
		$this->regVar("threadLst_notViewedIcon",		"msg_notViewed_0.gif",	false, true, "se_*");

		//mail options
		$this->regVar("mail_header",								"Someone has replied to your thread.", false, true, "se_*");
		$this->regVar("mail_sendfromName",					"forum",				false, true, "se_*");
		$this->regVar("mail_sendFromEmail",					NULL,						false, true, "se_*");
		$this->regVar("mail_displayEmail",					NULL,						false, true, "se_*");
		$this->regVar("mail_displayUrl",						NULL,						false, true, "se_*");

		// defaults
		$this->regVar("def_thread_smiley", 					NULL, 				false, true, "se_*");
		$this->regVar("def_thread_preview", 				"on",					 				false, true, "se_*");
		$this->regVar("def_thread_emailOnReply",		"off",				 				false, true, "se_*");
		$this->regVar("date_format",								"d.m.Y h:i:s", 				false, true, "se_*");

		/***********************
		* Paths and Media
		***/
		$this->regVar("root_url",						NULL,									false, true, "se_*");
		$this->regVar("media_dir", 					"/media", 						false, true, "se_*");
		$this->regVar("smileys_dir",				"media/smileys",			false, true, "se_*");
		$this->regVar("logo_dir",						"data",			false, true, "se_*");
		$this->regVar("styles_dir",					"/css",								false, true, "se_*");
		$this->regVar("stylesheet",					"styles.css",					false, true, "se_*");
		$this->regVar("session_id", 				NULL, 								false, false,"se_*");
	}	
}

?>