<?php
  $text = stripslashes($_POST['content']);
  $temptext = tempnam('/tmp', 'spell_');
  if ((!isset($_POST['dictionary'])) || (strlen(trim($_POST['dictionary'])) < 1))
  {
      $lang = 'en_GB';
  } //if
  else
  {
      $lang = $_POST['dictionary'];
  } //else


if(DIRECTORY_SEPARATOR == '\\') //windows
{
  $aspellcommand = 'C:\Progra~1\Aspell\bin\aspell.exe -a --mode=none --add-filter=sgml --encoding=utf-8 --lang='.$lang.' < '.$temptext;
  $aspelldictionaries = 'C:\Progra~1\Aspell\bin\aspell.exe dump dicts';
}
else //linux
{

  $aspellcommand = 'cat '.$temptext.' | aspell -a --mode=none --add-filter=sgml --encoding=utf-8 --lang='.$lang;
  $aspelldictionaries = 'aspell dump dicts';
}


##############################################################################

  echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" media="all" href="spell-check-style.css" />';

if (trim($text) != "")
{
    if ($fd = fopen($temptext, 'w'))
    {
        $textarray = explode("\n", $text);
        fwrite ($fd, "!\n");
        foreach ($textarray as $key=>$value)
        {
            // adding the carat to each line prevents the use of aspell commands within the text...
            fwrite($fd, "^$value\n");
        }
        fclose($fd);

        // next run aspell
        $return = shell_exec($aspellcommand);
    unlink($temptext);
        $returnarray = explode("\n", $return);
        $returnlines = count($returnarray);
//print_r(htmlentities($return));
        $textlines = count($textarray);

        $varlines = '<script type="text/javascript">var suggested_words = { ';
        $infolines = 'var spellcheck_info = {';

        $lineindex = -1;
        $poscorrect = 0;
        $counter = 0;
        $suggest_count = 0;
        foreach ($returnarray as $key=>$value)
        {
            // if there is a correction here, processes it, else move the $textarray pointer to the next line
            if (substr($value, 0, 1) == '&')
            {
               $counter=$counter+1;
                $correction = explode(' ', $value);
                $word = $correction[1];
                $suggest_count += $correction[2];
                $absposition = substr($correction[3], 0, -1) - 1;
                $position = $absposition + $poscorrect;
                $niceposition = $lineindex.','.$absposition;
                $suggstart = strpos($value, ':') + 2;
                $suggestions = substr($value, $suggstart);
                $suggestionarray = explode(', ', $suggestions);

                $beforeword = substr($textarray[$lineindex], 0, $position);
                $afterword = substr($textarray[$lineindex], $position + strlen($word));
                $textarray[$lineindex] = $beforeword.'<span class="HA-spellcheck-error">'.$word.'</span>'.$afterword;

             $suggestion_list = '';
                foreach ($suggestionarray as $key=>$value)
                {
                    $suggestion_list .= $value.',';
                }
                $suggestion_list = substr($suggestion_list, 0, strlen($suggestion_list) - 1);
                $varlines .= '"'.$word.'":"'.$suggestion_list.'",';

                $poscorrect = $poscorrect + 41;
            }
            elseif (substr($value, 0, 1) == '#')
            {
                $correction = explode(' ', $value);
                $word = $correction[1];
                $absposition = $correction[2] - 1;
                $position = $absposition + $poscorrect;
                $niceposition = $lineindex.','.$absposition;
                $beforeword = substr($textarray[$lineindex], 0, $position);
                $afterword = substr($textarray[$lineindex], $position + strlen($word));
                $textarray[$lineindex] = $beforeword.$word.$afterword;
                $textarray[$lineindex] = $beforeword.'<span class="HA-spellcheck-error">'.$word.'</span><span class="HA-spellcheck-suggestions">'.$word.'</span>'.$afterword;
//                $poscorrect = $poscorrect;
                $poscorrect = $poscorrect + 88 + strlen($word);
            }
            else
            {
                //print "Done with line $lineindex, next line...<br><br>";
                $poscorrect = 0;
                $lineindex = $lineindex + 1;
            }
         }
     }
}
$infolines .= '"Language Used":"'.$lang.'",';
$infolines .= '"Mispelled words":"'.$counter.'",';
$infolines .= '"Total words suggested":"'.$suggest_count.'",';
$infolines .= '"Total Lines Checked":"'.$returnlines.'"';
$infolines .= '};';
$varlines = substr($varlines, 0, strlen($varlines) - 1);
echo $varlines.'};'.$infolines.'</script>';

echo '</head>
<body onload="window.parent.finishedSpellChecking();">';

foreach ($textarray as $key=>$value)
{
  echo $value;
}

$dictionaries = str_replace(chr(10),",", shell_exec($aspelldictionaries));
echo '<div id="HA-spellcheck-dictionaries">'.$dictionaries.'</div></body></html>';
//echo '<div id="HA-spellcheck-dictionaries">en_US,es,fr</div></body></html>';
?>